package com.yihu.wlyy.controller;

import com.yihu.wlyy.controller.endpoint.Envelop;
import com.yihu.wlyy.util.FtpFilesUtil;
import org.json.JSONArray;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.MediaType;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


/**
 * Created by zdm on 2019/5/7.
 */
@RestController
@RequestMapping(value = "/ftp/files", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
public class FileDownloadController {
    //图片服务地址

    @Value("${ftp.url}")
    private String URL;
    @Value("${ftp.port}")
    private int PORT;
    @Value("${ftp.user}")
    private String USER;
    @Value("${ftp.pwd}")
    private String PWD;
    @Value("${wlyy.url}")
    private String wlyyUrl;
    @Autowired
    private  FtpFilesUtil ftpFilesUtil;

    @RequestMapping(value = "fileDownloadLocal", method = RequestMethod.GET)
    public Envelop fileDownloadLocal() {
        Envelop envelop = new Envelop();
        try {
            ftpFilesUtil.getFileListByPathTest1(URL, PORT, USER, PWD, "/data/rec2/2019/0507/08/");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return envelop;
    }

    /**
     * job执行ftp文件上传至dfs
     */
    @Scheduled(cron = "0 0 23 * * ?")
    public void fileDownloadJob() {
        try {
            ftpFilesUtil.uploadFtpFileJobByDate(URL, PORT, USER, PWD);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 上传指定路径的文件
     * @param fileRemotePath
     */
    @RequestMapping(value = "uploadFtpFileByPath", method = RequestMethod.GET)
    public void uploadFtpFileByPath(String fileRemotePath){
        try {
            ftpFilesUtil.uploadFtpFileByPath(URL,PORT,USER,PWD,fileRemotePath);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 手动执行上传今天的文件
     */
    @RequestMapping(value = "fileDownloadByDate", method = RequestMethod.GET)
    public void fileDownloadByDate(){
        try {
            ftpFilesUtil.uploadFtpFileJobByDate(URL,PORT,USER,PWD);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
